VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   7320
   ClientTop       =   3885
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   2880
      TabIndex        =   2
      Text            =   "20"
      Top             =   2280
      Width           =   1575
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   2880
      TabIndex        =   1
      Text            =   "20"
      Top             =   1560
      Width           =   1575
   End
   Begin MSComDlg.CommonDialog CommonDialog2 
      Left            =   3960
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   3240
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Start"
      Height          =   975
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Y Shift"
      Height          =   255
      Left            =   1680
      TabIndex        =   4
      Top             =   2400
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "X Shift"
      Height          =   255
      Left            =   1680
      TabIndex        =   3
      Top             =   1680
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit






Private Sub Command1_Click()
    Dim fn1 As New CFileName 'to handle the filenames
    Dim fn2 As New CFileName
    
    Dim SFile1 As New CShapeFile 'to handle the shapeIO
    Dim SFile2 As New CShapeFile
    
    Dim s1 As IShape
    
    Dim polyg1 As CPolygon  'to handle polygons
    Dim polyg2 As CPolygon
    Dim polyl1 As CPolyLine 'to handle polylines
    Dim polyl2 As CPolyLine
    Dim mult1 As CMultiPoint
    Dim mult2 As CMultiPoint
    Dim part1 As CPart  'to handle parts
    Dim part2 As CPart
    Dim pnt1 As CPoint  'to handle points
    Dim pnt2 As CPoint
    
    Dim ShapeCount As Long
    Dim i As Long
    Dim j As Long
    
    On Error GoTo DIALOG_ERROR
    With CommonDialog1
        .CancelError = True
        .Filter = "ShapeFiles (*.shp)|*.shp"
        .FilterIndex = 1
        .DialogTitle = "Select a shapefile to shift"
        .ShowOpen
        fn1.SetFileSpec = .FileName
    End With
        
    With CommonDialog2
        .CancelError = True
        .Filter = "ShapeFiles (*.shp)|*.shp"
        .FilterIndex = 1
        .DialogTitle = "Select a shapefile to save to"
        .ShowSave
        fn2.SetFileSpec = .FileName
    End With
        
    On Error GoTo ERROR_ROUTINE
    
    SFile1.SetFileSpec fn1, OPENIT  'open the input shape file
    SFile2.SetFileSpec fn2, CREATEIT, SFile1.FileType   'create the output shapefile
    
    ShapeCount = SFile1.Count 'how many shapes
    
    Select Case SFile1.FileType
        Case SHAPEFILETYPE.typePoint
            For i = 1 To 10
                Set pnt1 = SFile1.Item(i)
                Set s1 = pnt1
                Set pnt2 = New CPoint
                If (s1.IsNull = False) Then ' if shape is null then won't add it
                    Debug.Print i, pnt1.X, pnt1.Y
                    pnt2.X = pnt1.X + CDbl(Text1.Text)
                    pnt2.Y = pnt1.Y + CDbl(Text2.Text)
                    SFile2.Add pnt2
                End If
            Next
        Case SHAPEFILETYPE.typeMultiPoint
            For i = 1 To ShapeCount
                Set mult1 = SFile1.Item(i)
                Set s1 = mult1
                If (s1.IsNull = False) Then ' if shape is null then won't add it
                    Set mult2 = New CMultiPoint
                    For Each pnt1 In mult1
                        pnt2 = New CPoint
                        pnt2.X = pnt1.X + CDbl(Text1.Text)
                        pnt2.Y = pnt1.Y + CDbl(Text2.Text)
                        mult2.Add pnt2
                    Next
                    SFile2.Add mult2
                End If
            Next
        Case SHAPEFILETYPE.typePolyLine
            For i = 1 To ShapeCount
                Set polyl1 = SFile1.Item(i)
                Set s1 = polyl1
                If (s1.IsNull = False) Then ' if shape is null then won't add it
                    Set polyl2 = New CPolyLine
                    For Each part1 In polyl1
                        Set part2 = New CPart
                        For Each pnt1 In part1
                            Set pnt2 = New CPoint
                            pnt2.X = pnt1.X + CDbl(Text1.Text)
                            pnt2.Y = pnt1.Y + CDbl(Text2.Text)
                            part2.Add pnt2
                        Next
                        polyl2.Add part2
                    Next
                    SFile2.Add polyl2
                End If
            Next
        Case SHAPEFILETYPE.typePolygon
            For i = 1 To ShapeCount
                Set polyg1 = SFile1.Item(i)
                Set s1 = polyg1
                If (s1.IsNull = False) Then ' if shape is null then won't add it
                    Set polyg2 = New CPolygon
                    For Each part1 In polyg1
                        Set part2 = New CPart
                        For Each pnt1 In part1
                            Set pnt2 = New CPoint
                            pnt2.X = pnt1.X + CDbl(Text1.Text)
                            pnt2.Y = pnt1.Y + CDbl(Text2.Text)
                            part2.Add pnt2
                        Next
                        polyg2.Add part2
                    Next
                    SFile2.Add polyg2
                End If
            Next
        Case Else
            Err.Raise 9999, "button click", "Unsupported shape type"
    End Select

    Set fn1 = Nothing
    Set fn2 = Nothing
    Set SFile1 = Nothing
    Set SFile2 = Nothing
    
    MsgBox "ALL DONE"
    
    Exit Sub

DIALOG_ERROR:
    MsgBox "You pressed cancel"
    Exit Sub
    
ERROR_ROUTINE:
    Err.Raise Err.Number, Err.Source, Err.Description
    Exit Sub
End Sub


